=== libsrc/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(general)
add_subdirectory(gprim)
add_subdirectory(linalg)
add_subdirectory(include)
add_subdirectory(meshing)
if(USE_OCC)
    add_subdirectory(occ)
endif(USE_OCC)
if(USE_STLGEOM)
    add_subdirectory(stlgeom)
endif(USE_STLGEOM)
if(USE_GUI)
    add_subdirectory(visualization)
endif(USE_GUI)
if(USE_INTERFACE)
    add_subdirectory(interface)
endif(USE_INTERFACE)
if(USE_CSG)
    add_subdirectory(csg)
endif(USE_CSG)
if(USE_GEOM2D)
    add_subdirectory(geom2d)
endif(USE_GEOM2D)
