=== py_tutorials/CMakeLists.txt ===
install( FILES 
        shaft.geo mesh.py exportNeutral.py
        DESTINATION ${NG_INSTALL_DIR_RES}/${NG_INSTALL_SUFFIX}/py_tutorials
        COMPONENT netgen_tutorial
       )
