=== debian/changelog ===
netgen (6.2.2501+dfsg1-12) unstable; urgency=medium

  * Team upload.
  * apply armel test skips to debian/tests (netgen-test-python)

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Apr 2025 15:40:49 +0200

netgen (6.2.2501+dfsg1-11) unstable; urgency=medium

  * Team upload.
  * armel: skip test_BBNDsave
    Now it passes, now it fails. This is madness.

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 22:20:09 +0200

netgen (6.2.2501+dfsg1-10) unstable; urgency=medium

  * Team upload.
  * There are too many pytest segfaults on armel.
    Skip all test_geoFiles

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 18:31:12 +0200

netgen (6.2.2501+dfsg1-9) unstable; urgency=medium

  * Team upload.
  * armel: skip test_geoFiles[boundarycondition

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 15:51:37 +0200

netgen (6.2.2501+dfsg1-8) unstable; urgency=medium

  * Team upload.
  * armel: skip test_2_polyhedra and all slow tests
    (internal skips are causing segfaults)

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 12:18:24 +0200

netgen (6.2.2501+dfsg1-7) unstable; urgency=medium

  * Team upload.
  * armel: skip all tests that need ngsolve.  importorskip in-test
    is triggering segfaults on armel

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Apr 2025 00:47:30 +0200

netgen (6.2.2501+dfsg1-6) unstable; urgency=medium

  * Team upload.
  * armel: skip test_wrong_orientation

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Apr 2025 19:03:46 +0200

netgen (6.2.2501+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * armel: skip test_geoFiles[sphereincube

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Apr 2025 09:45:45 +0200

netgen (6.2.2501+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * armel: skip test_geoFiles[cubeandspheres build tests
  * sparc64: skip all occ tests

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Apr 2025 18:38:53 +0200

netgen (6.2.2501+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * skip failing tests
    - armel: test_boundarylayer2
    - powerpc: actually skip test_geoFiles[sphereincube.geo-mp161-4]
    - sparc64: skip all test_occ (is it a numpy linalg issue?)

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Apr 2025 10:42:40 +0200

netgen (6.2.2501+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * skip failing tests on less common architectures
    - armel: test_mesh_elements_numpy_array_access
    - powerpc: test_geoFiles[sphereincube.geo-mp161-4]
    - sparc64: test_rect_with_two_holes
  * debian/copyright: update FSF address used in LGPL

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Apr 2025 20:08:13 +0200

netgen (6.2.2501+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * reduce debian patch size_t_int32.patch: upstream has added some
    int size checks in table.hpp
  * mark libnglib-dev Multi-Arch: same
  * debian/control: set Homepage: https://github.com/NGSolve/netgen
    to avoid confusion with ngsolve. Also Source in debian/copyright.
  * drop redundant ng/Togl-1.7 exclusions from debian/copyright
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Apr 2025 11:49:01 +0200
