=== debian/tests/control ===
Tests: netgen-test-cpp
Depends: libnglib-dev,
 netgen, python3-netgen,
 gcc, g++, cmake, catch2,
 mpi-default-dev
Restrictions: allow-stderr

Tests: netgen-test-python
Depends: python3-netgen,
 gcc, python3-numpy,
 python3-pytest, python3-pytest-mpi,
 mpi-default-bin, python3-mpi4py
