## netgen 6.2.2601%2Bdfsg1

=== debian/changelog ===
netgen (6.2.2601+dfsg1-3ubuntu1) resolute; urgency=medium

  * Also skip test_geoFiles on amd64v3 (LP: #2137482)

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 22 Feb 2026 12:31:46 +0000

netgen (6.2.2601+dfsg1-3) unstable; urgency=medium

  * Pass -flax-vector-conversions to CXXFLAGS on arm64 also in
    debian/tests/netgen-test-cpp
  * Drop redundant Priority field from d/control

 -- Francesco Ballarin <ballarin@debian.org>  Sun, 22 Feb 2026 06:40:09 +0000

netgen (6.2.2601+dfsg1-2) unstable; urgency=medium

  * Add -flax-vector-conversions to CXXFLAGS on arm64 to avoid build failures
    due to conversion errors. An issue is already open upstream at
    https://github.com/NGSolve/netgen/issues/226

 -- Francesco Ballarin <ballarin@debian.org>  Fri, 20 Feb 2026 12:18:42 +0000

netgen (6.2.2601+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Add Francesco Ballarin to uploaders.
  * Standards-Version: 4.7.3 (routine-update)
  * Update watch file format version to 5.
  * Add dversionmangle for repack versioning in debian/watch.
  * Reorder Files paragraphs in debian/copyright by directory depth.
  * Set upstream metadata fields: Bug-Database, Repository.
  * debputy lint --auto-fix (routine-update)
  * Apply multi-arch hint:
    - netgen-headers: Add Multi-Arch: same.
  * Add debian/clean (from Alexandre Detiste)
  * Add debian/salsa-ci.yml (from Alexandre Detiste)
  * Use dh-sequence-python3 (from Alexandre Detiste)
  * Drop "Rules-Requires-Root: no", as it is the default now (from Alexandre
    Detiste)
  * Refresh patches
  * Add link-libjpeg-netgen-exec.patch to force netgen executable to link
    libjpeg.
  * Fix lintian warning old-fsf-address-in-copyright-file.

 -- Francesco Ballarin <ballarin@debian.org>  Fri, 20 Feb 2026 10:18:29 +0000
